%ADESDZ Analytical design for phase lead and phase lag controllers.

%  Copyright
%  Charles L. Phillips  1994

delete dsn.dat
clc
diary dsn.dat
disp('             ANALYTICAL DIGITAL CONTROLLER DESIGN ')
disp(' ')
diary off
disp('  The open-loop function used in the design is:   K*G(w)*Hk')
disp(' ')
disp(' Enter the forward path gain K and the sensor gain Hk:')
fpgk=input('            gain K = ');
fbghk=input('           gain Hk = ');

disp(' ')
disp('  Enter the required parameters: ')
a0=input('                    Filter dc gain   a0 = ');
phim=input('            Desired phase margin   phim = ');
ww1=input('   Phase margin w-plane frequency   ww1 = ');
gw1=fpgk*fbghk*polyval(ngw,j*ww1)/polyval(dgw,j*ww1);
gw1mag=abs(gw1);
thetad=180+phim-angle(gw1)*180/pi; thetar=thetad*pi/180;
diary on
disp(' ')
disp('  Designed filter coefficients:')
disp(' ')
a0
disp(' ')
a1=(1-a0*gw1mag*cos(thetar))/(ww1*gw1mag*sin(thetar))
disp(' ')
b1=(cos(thetar)-a0*gw1mag)/(ww1*sin(thetar))

%  D(w)

disp(' ')
disp('  Designed filter:   D(w) = ndw/ddw')
disp(' ')
ndw=[a1  a0]
disp(' ')
ddw=[b1  1]

disp(' ')
diary off
disp('  Press any key to continue ...'); pause

disp(' ')
diary on
disp('  For verification, the magnitude and phase of the open-loop')
disp(' ')
disp('  function:     OLF = K*D(jww1)*G(jww1)*Hk,     are:')
OLF=gw1*polyval(ndw,j*ww1)/polyval(ddw,j*ww1);
disp(' ')
magOLF=abs(OLF)
disp(' ')
angleOLF=angle(OLF)*180/pi
disp(' ')
diary off
disp('  Press any key to continue ...'); pause

%  D(z)

wzn=[2/T  -2/T];  wzd=[1  1];
disp(' ')
diary on
disp('  Designed filter:    D(z) = ndz/ddz')
ndz=ndw(1)*wzn + ndw(2)*wzd;
ddz=ddw(1)*wzn + ddw(2)*wzd;
disp(' ')
ndz=ndz/ddz(1)
disp(' ')
ddz=ddz/ddz(1)
filterin = 1;

dtz=conv(ddz,dgz) + conv(ndz,ngz)*fpgk*fbghk;
disp(' ')
disp('  z-plane roots of the closed-loop system characteristic equation:')
disp(' ')
z_plane_roots=roots(dtz)
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the design results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print dsn.dat
end

disp(' ')
disp('  Press any key to return to menu.'), pause;clc



