%ADESGA Analytical design for phase lead and phase lag controllers.

%  Copyright
%  Charles L. Phillips  1994

delete dsn.dat
clc
diary dsn.dat
disp(' ')

disp('             ANALYTICAL ANALOG CONTROLLER DESIGN ')
disp(' ')
diary off
disp('  The open-loop function used in the design is:   K*G(w)*Hk')
disp(' ')
disp(' Enter the forward path gain K and the sensor gain Hk:')
fpgk=input('            gain K = ');
fbghk=input('           gain Hk = ');

disp(' ')
disp('  Enter the required parameters: ')
a0=input('                    Filter dc gain   a0 = ');
phim=input('            Desired phase margin   phim = ');
w1=input('            Phase margin frequency   w1 = ');
gw1=fpgk*fbghk*polyval(ngps,j*w1)/polyval(dgps,j*w1);
gw1mag=abs(gw1);
thetad=180+phim-angle(gw1)*180/pi; thetar=thetad*pi/180;
diary dsn.dat
disp(' ')
K = fpgk
Hk = fbghk
disp(' ')
disp('  Designed filter coefficients:')
disp(' ')
a0
disp(' ')
a1=(1-a0*gw1mag*cos(thetar))/(w1*gw1mag*sin(thetar))
disp(' ')
b1=(cos(thetar)-a0*gw1mag)/(w1*sin(thetar))

%  Gc(s)

disp(' ')
disp('  Designed filter:   Gc(s) = ngcs/dgcs')
disp(' ')
ngcs=[a1  a0]
disp(' ')
dgcs=[b1  1]
diary off
disp(' ')
disp('  Press any key to continue ...'); pause
diary on
disp(' ')
disp('  For verification, the magnitude and phase of the open-loop')
disp(' ')
disp('  function:     OLF = K*Gc(jw1)*Gp(jw1)*Hk,     are:')
OLF=gw1*polyval(ngcs,j*w1)/polyval(dgcs,j*w1);
disp(' ')
magOLF=abs(OLF)
disp(' ')
angleOLF=angle(OLF)*180/pi
diary off
disp(' ')
disp('  Press any key to continue ...'); pause
diary on
filterin = 1;

dts=conv(dgcs,dgps) + conv(ngcs,ngps)*fpgk*fbghk;
disp(' ')
disp('  s-plane roots of the closed-loop system characteristic equation:')
disp(' ')
s_plane_roots=roots(dts)

disp(' ')
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the calculated data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print dsn.dat
end
clc

disp('  Press any key to return to menu.'), pause;clc



