%ADSPDA Analytical design for analog PID controllers.

%  Copyright
%  Charles L. Phillips  1994

delete dsnpid.dat
clc
diary dsnpid.dat
disp(' ')

disp('                ANALYTICAL PID ANALOG CONTROLLER DESIGN ')

disp(' ')
diary off
disp(' ')
disp('  The open-loop function used in the design is:   K*Gp(s)*Hk')
disp(' ')
disp('   Enter the forward path gain K and the sensor gain Hk')
fpgk=input('           gain K = ');
fbghk=input('          gain Hk = ');

disp(' ')
disp('  Choose the design desired:')
disp(' ')
disp('       1.  PI design')
disp(' ')
disp('       2.  PD design')
disp(' ')
disp('       3.  PID design')
disp(' ')
q2=input(' Enter 1, 2, or 3:  ');
phim=input('            Desired phase margin:   phim = ');
w1=input('            Phase margin frequency:   w1 = ');

gpw1=fpgk*fbghk*polyval(ngps,j*w1)/polyval(dgps,j*w1);
gpw1mag=abs(gpw1);
thetad=180+phim-angle(gpw1)*180/pi;
thetar=thetad*pi/180;

Kp=cos(thetar)/gpw1mag;

if q2==1
   Ki=-sin(thetar)*w1/gpw1mag;
   Kd=0;

elseif q2==2

   Kd=sin(thetar)/(w1*gpw1mag);
   Ki=0;

elseif q2==3

   Ki=input(' Enter the integrator gain: Ki = ');
   Kd=sin(thetar)/(w1*gpw1mag) + Ki/(w1^2);

end
diary dsnpid.dat
disp(' ')
K = fpgk
Hk = fbghk

disp(' ')
disp('  Designed filter coefficients:')
disp(' ')
Kp
disp(' ')
Ki
disp(' ')
Kd

%  Gc(s)

if q2==1
   ngcs=[Kp  Ki];
   dgcs=[1  0];

elseif q2==2
   ngcs=[Kd  Kp];
   dgcs=[0  1];

elseif q2==3
   ngcs=[Kd  Kp  Ki];
   dgcs=[0  1  0];
end

disp(' ')
disp('  The controller transfer function is    Gc(s)= ngcs/dgcs')
disp(' ')
ngcs
disp(' ')
dgcs
diary off
disp(' ')
disp('  Press any key to continue ...'); pause
diary on

disp(' ')
disp('  For verification, the magnitude and phase of the open-loop')
disp(' ')
disp('  function:       OLF = K*Gc(jw1)*Gp(jw1)*Hk,       are:')
OLF=gpw1*polyval(ngcs,j*w1)/polyval(dgcs,j*w1);
disp(' ')
magOLF=abs(OLF)
disp(' ')
angleOLF=angle(OLF)*180/pi
diary off
disp(' ')
disp('  Press any key to continue ...'); pause
diary on
dts=conv(dgcs,dgps) + conv(ngcs,ngps)*fpgk*fbghk;
disp(' ')
disp('  Roots of the closed-loop system characteristic equation:')
disp(' ')
s_plane_roots=roots(dts)
disp(' ')
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the calculated data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print dsnpid.dat
end
clc

disp('  Press any key to return to menu.'), pause;clc






