%ADSPDD Analytical design for phase lead and phase lag controllers.

%  Copyright
%  Charles L. Phillips  1994

delete dsnpid.dat
clc
diary dsnpid.dat
disp('                ANALYTICAL PID DIGITAL CONTROLLER DESIGN ')

disp(' ')
diary off
disp(' ')
disp('  The open-loop function used in the design is:   K*G(w)*Hk')
disp(' ')
disp('   Enter the forward path gain K and the sensor gain Hk')
fpgk=input('           gain K = ');
fbghk=input('          gain Hk = ');

disp(' ')
disp('  Choose the design desired:')
disp(' ')
disp('       1.  PI design')
disp(' ')
disp('       2.  PD design')
disp(' ')
disp('       3.  PID design')
disp(' ')
q2=input(' Enter 1, 2, or 3:  ');
phim=input('            Desired phase margin:   phim = ');
ww1=input('   Phase margin w-plane frequency:   ww1 = ');

gw1=fpgk*fbghk*polyval(ngw,j*ww1)/polyval(dgw,j*ww1);
gw1mag=abs(gw1);
thetad=180+phim-angle(gw1)*180/pi;
thetar=thetad*pi/180;
Kp=cos(thetar)/gw1mag;
if q2==1
   Ki=-sin(thetar)*ww1/gw1mag;
   Kd=0;

elseif q2==2

   Kd=sin(thetar)/(ww1*gw1mag);
   Ki=0;

elseif q2==3

   Ki=input(' Enter the integrator gain: Ki = ');
   Kd=sin(thetar)/(ww1*gw1mag) + Ki/(ww1^2);

end
diary on
disp(' ')
K = fpgk
Hk = fbghk
disp(' ')
disp('  Designed filter coefficients:')
disp(' ')
Kp
disp(' ')
Ki
disp(' ')
Kd

%  D(w)

if q2==1
   ndw=[Kp  Ki];
   ddw=[1  0];

elseif q2==2
   ndw=[Kd+Kp*T/2  Kp];
   ddw=[T/2  1];

elseif q2==3
   ndw=[Kd+Kp*T/2  Kp+Ki*T/2  Ki];
   ddw=[T/2  1  0];
end
disp(' ')
disp('  Designed filter:   D(w) = ndw/ddw')
disp(' ')
ndw
disp(' ')
ddw
disp(' ')
diary off
disp('  Press any key to continue ...'); pause

disp(' ')
diary on
disp('  For verification, the magnitude and phase of the open-loop')
disp(' ')
disp('  function:       OLF = K*D(jww1)*G(jww1)*Hk,       are:')
OLF=gw1*polyval(ndw,j*ww1)/polyval(ddw,j*ww1);
disp(' ')
magOLF=abs(OLF)
disp(' ')
angleOLF=angle(OLF)*180/pi

disp(' ')
diary off
disp('  Press any key to continue ...'); pause


%  D(z)

KiT2=Ki*T/2;
KdT=Kd/T;
if q2==1
   ndz=[KiT2+Kp  KiT2-Kp];
   ddz=[1  -1];

elseif q2==2
   ndz=[KdT+Kp  -KdT];
   ddz=[1  0];

elseif q2==3
   ndz=[KdT+Kp+KiT2  KiT2-Kp-2*KdT  KdT];
   ddz=[1  -1  0];
end
diary on
disp(' ')
disp('  Designed filter:    D(z) = ndz/ddz')
disp(' ')
ndz
disp(' ')
ddz
filterin = 1;

dtz=conv(ddz,dgz) + conv(ndz,ngz)*fpgk*fbghk;
disp(' ')
disp('  z-plane roots of the closed-loop system characteristic equation:')
disp(' ')
z_plane_roots=roots(dtz)
disp(' ')
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the design results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print dsnpid.dat
   clc
end

disp('  Press any key to return to menu.'), pause;clc



