%BDEA Bode diagram.

%  Copyright
%  Charles L. Phillips  1994

delete bode.dat
clc

ngols=ngps;
dgols=dgps;
diary bode.dat
disp('                        BODE DIAGRAM ')
diary off
if filterin ==1
   disp(' '), disp(' ')
   disp('  OPTIONS:')
   disp(' ')
   disp('        1.  Bode diagram for K*Gp(s)*Hk')
   disp(' ')
   disp('        2.  Bode diagram for K*Gc(s)*Gp(s)*Hk')
   q1=input(' Enter 1 or 2: ');

   if q1==2

      ngols=conv(ngps,ngcs);
      dgols=conv(dgps,dgcs);
   end

end

disp(' ')
disp('   Enter the forward path gain K and the sensor gain Hk:')
fpgk=input('           gain K = ');
fbghk=input('          gain Hk = ');
disp(' ')
disp('   Enter the frequency range: wi <= w <= wf  with n increments,')
disp('   where wi=10^a and wf=10^b.  Enter only a and b:')
a=input('               For initial value  a = ');
b=input('                 For final value  b = ');
nn=input('   Number of increments in range  n = ');

s=input('   Do you want the closed-loop frequency response? [y/n]: ','s');

w=logspace(a,b,nn);
disp(' ')

ngols=fpgk*fbghk*ngols;

diary on
disp(' ')
K = fpgk
Hk = fbghk

if s=='y'
   dgols=dgols + ngols;
   ngols=ngols/fbghk;
   disp('           CLOSED-LOOP SYSTEM FREQUENCY RESPONSE')
end

[mag,phase,w]=bode(ngols,dgols,w);

if s~='y'
   disp('           OPEN-LOOP FUNCTION FREQUENCY RESPONSE')
end

db=20*log10(mag);
disp(' ')
disp('   omega      mag        db        arg')
pr=length(w);  count=3;

for i=1:pr
   [w(i),mag(i),db(i),phase(i)]
diary off
   if count==10
      disp(' '), disp('Press any key to continue ...'),disp(' '), pause
      count=0;
      disp('   omega      mag        db        arg')
   end  

   count=count+1;
diary on
end
diary off
disp(' ')
disp('Press any key for the plots of the Bode diagram.'); pause
subplot(211), semilogx(w,db)
title('Bode diagram'); xlabel('frequency');
ylabel('dB'); grid
subplot(212), semilogx(w,phase)
xlabel('frequency'); ylabel('phase'); grid
pause, subplot (111), clc
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the Bode diagram data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print bode.dat
end
clc



