%BDE Bode diagram.

%  Copyright
%  Charles L. Phillips  1994

delete bode.dat
clc

ndgw=ngw;
ddgw=dgw;
diary bode.dat
disp('                        BODE DIAGRAM ')
disp(' ')
diary off
if filterin ==1
   disp(' '), disp(' ')
   disp('  OPTIONS:')
   disp(' ')
   disp('        1.  Bode diagram for K*G(z)*Hk')
   disp(' ')
   disp('        2.  Bode diagram for K*G(z)*D(z)*Hk')
   q1=input(' Enter 1 or 2: ');

   if q1==2
      ndgw=conv(ngw,ndw);
      ddgw=conv(dgw,ddw);
   end

end

disp(' ')
disp('   Enter the forward path gain K and the sensor gain Hk:')
fpgk=input('                             gain K = ');
fbghk=input('                             gain Hk = ');
disp(' ')
disp('   Enter the w-plane frequency range: wwi <= ww <= wwf  with n')
disp('   increments, where wwi=10^a and wwf=10^b.  Enter only a and b:')
a=input('               For initial value  a = ');
b=input('                 For final value  b = ');
nn=input('   Number of increments in range  n = ');

s=input('  Do you want the closed-loop frequency response? [y/n]: ','s');

ww=logspace(a,b,nn);
w=2/T*atan(ww*T/2);
disp(' ')

ndgwk=fpgk*fbghk*ndgw;

if s=='y'
   ddgw=ddgw + ndgwk;
   ndgw=ndgwk/fbghk;
diary on
   disp('           CLOSED-LOOP SYSTEM FREQUENCY RESPONSE')
   disp(' ')
diary off
end

[mag,phase,ww]=bode(ndgwk,ddgw,ww);

if s~='y'
diary on
   disp('           OPEN-LOOP FUNCTION FREQUENCY RESPONSE')
   disp(' ')
diary off
end

db=20*log10(mag);
disp(' ')
diary on
disp('   omegaw=ww   omega   mag(jww)   db(jww)   arg(jww)')
disp(' ')
pr=length(ww);  count=3;

for i=1:pr
   [ww(i),w(i),mag(i),db(i),phase(i)]

   if count==10
diary off
      disp(' '), disp('  Press any key to continue ...'),disp(' '), pause
      count=0;
      disp('   omegaw=ww   omega   mag(jww)   db(jww)   arg(jww)')
diary on
   end  

   count=count+1;

end
diary off
disp(' ')
disp('  Press any key for the plots of the Bode diagram.'); pause
subplot(211), semilogx(ww,db)
title('Bode diagram'); xlabel('w-plane frequency');
ylabel('dB'); grid
subplot(212), semilogx(ww,phase)
xlabel('w-plane frequency'); ylabel('phase'); grid
pause
clc
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input('  Do you want the Bode diagram data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print bode.dat
end
clc
disp('  Press any key to return to the menu'); pause, subplot (111), clc
