%BRKPTS  Breakpoints for a root locus.

%  Copyright
%  Charles L. Phillips  1994

clear nprime dprime rts nnn Kbp p
for ii=1:orderrl
   iin=orderrl+1-ii;
   nprime(ii)=num(ii)*iin;
   dprime(ii)=den(ii)*iin;
end
p=conv(den,nprime)-conv(num,dprime);
rts=roots(p);
nnn=length(rts);
diary on
if nnn ~= 0
   disp(' ')
   disp('  The gains K and the corresponding breakpoints are:')
   disp(' ')
   disp('       K      Breakpoints')
   disp(' ')
   for ii=1:nnn
      Kbp(ii) = abs(polyval(den,rts(ii))/polyval(num,rts(ii)));
   end
   [Kbp',rts]
else
   disp(' ')
   disp('  No break points')
   disp(' ')
end
diary off
disp(' ')
disp('  Press any key to continue ...'), pause, diary on, clc

