%CES Current state estimator.

%  Copyright
%  Charles L. Phillips  1994

delete cues.dat
clc
clear G
clear ale
preest=0; roeest=0; curest=1; kalest=0;
diary cues.dat
disp('                         CURRENT ESTIMATOR DESIGN')
disp(' ')
diary off
disp(' ')
disp('  The plant is described by:')
disp(' ')
disp('                         x(k + 1) = Ax(k) + Bu(k)')
disp(' ')
disp('                             y(k) = Cx(k)')
disp(' ')
disp('  The state estimator is described by:')
disp(' ')
disp('                         q(k + 1) = Fq(k) + Gy(k + 1) + Hu(k)')
disp(' '), 
disp('  where F = (A - GC).  The desired state-estimator characteristic')
disp('  equation is of the form, with ale(n) = 1:')
disp(' ')
disp('   ale(n)*z^n + ale(n -1)*z^(n - 1) + ... + ale(1)*z + ale(0) = 0')
disp(' ')
disp('  Press any key to continue ...'), pause
disp(' ')
disp('  Enter the characteristic-equation coefficients in descending order')
disp('  of n, with each coefficient followed by pressing the enter key.')

for ii=1:(order+1)
   jj=order+1-ii;
   jjj=int2str(jj);
   str1=['    ale(',jjj,')= '];
   ale(ii) = input(str1);
end

disp(' ')
diary on
disp('  The characteristic-equation coefficients are:')
disp(' ')
ale
AMC=C*A;
AMCT=AMC;

for n=2:order
   AMCT=AMCT*A;

   for nn=1:order
      AMC(n,nn)=AMCT(1,nn);
   end

end

AMCI=inv(AMC);
CC=polyvalm(ale,A);
CCC = CC*AMCI;
disp(' ')
disp('  The gain matrix G is:'), disp(' ')
G=CCC(:,order)
disp(' ')
diary off
disp('  Press any key to continue ...'), pause
diary on
disp(' ')
disp('  The closed-loop estimator matrix   AG = A - G*C*A   is:'), disp(' ')
AG=A-G*C*A
disp(' ')
diary off
disp('  Press any key to continue ...'), pause
diary on
disp(' ')
disp('  For verification, the closed-loop characteristic-equation ')
disp('  coefficients for the estimator, calculated from AG, are:')
disp(' ')
ale=poly(AG)
disp(' ')
disp('  The estimator characteristic-equation roots in rectangular form')
disp('  are:')
disp(' ')
r=roots(ale)
disp(' ')
disp('  The estimator characteristic-equation roots in polar form are:')
disp(' ')
magr=abs(r); phaser=angle(r)*180/pi;
[magr,phaser]
diary off
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print cues.dat
   clc
end

disp(' ')
disp('  Press any key to return to the menu.'), pause, clc



