%CETF Controller-estimator transfer function.

%  Copyright
%  Charles L. Phillips  1994

delete coes.dat
clc
clear ACL ndecs alpha ngecs
diary coes.dat
disp('              CONTROLLER-ESTIMATOR TRANSFER FUNCTION')
disp(' ')
diary off
disp(' ')
disp('    1.  A pole-assignment design required.')
disp(' ')
disp('    2.  An estimator design required.')
disp(' ')
disp('  With Y(s) the plant output and U(s) the plant input, the')
disp('  controller-estimator transfer function Gec(s) is given by:')
disp(' ')
disp('                      Gec(s) = -U(s)/Y(s)')
disp(' ')

if poleas==1
diary on
   if preest==1 

      ACL=A-B*K-G*C;
      disp('  The numerator and denominator polynomials of Gec(s) are:')
      disp(' ')
      [ngecs,dgecs]=ss2tf(ACL,G,K,0);
      ngecs
      dgecs

   elseif roeest==1

      klen=length(C);

      for i=1:(klen-1)
         Kb(i)=K(i+1);
      end

      ACL=Abb-G*Aab-(Bb-G*Ba)*Kb;
      disp('  The numerator and denominator polynomials of Gec(s) are:')
      disp(' ')
      [n1,d1]=ss2tf(ACL,G,Kb,0);
      G1=Aba-G*Aaa-K(1)*(Bb-G*Ba);
      [n2,dgecs]=ss2tf(ACL,G1,Kb,0);

      for i=1:(klen-1)
         n(i)=n1(i+1) + n2(i);
      end

      n(klen)=n2(klen);

      for i=1:klen
         ngecs(i) = n(i)+K(1)*dgecs(i);
      end

      ngecs
      dgecs

   end

   disp(' ')
   diary off
   disp('  Press any key to continue ...'), pause
   disp(' ')
    diary on
   disp('  For verification, from         1 + Gec(s)G(s) = 0,')
   disp('  the characteristic-polynomial coefficients are:'), disp(' ')
   alpha=conv(dgecs,dgps) + conv(ngecs,ngps)
   disp(' ')
   diary off
   disp('  Press any key to continue ...'), pause
   disp(' ')
   diary on
   disp('  The roots of the characteristic equation in rectangular form are:')
   disp(' ')
   r=roots(alpha)
   disp(' ')
   disp('  The roots of the characteristic equation in polar form are:')
   disp(' ')
   magr=abs(r); angler=angle(r)*180/pi;
   [magr,angler]
   diary off
   disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
   s=input(' Do you want the results printed? [y/n]: ','s');
   if s=='y'
      ! copy iden.dat prn:
      ! print coes.dat
      clc
   end
   disp(' ')
   disp('  Press any key to return to the menu.'), pause, clc

else
   diary on
   disp('  No pole assignment design performed.')
   diary off
   disp(' ')
   s=input(' Do you want the results printed? [y/n]: ','s');
   if s=='y'
      ! copy iden.dat prn:
      ! print coes.dat
   clc
   end

   disp(' ')
   disp('  Press any key to return to the menu.'), pause, clc
end


