%CLSMA Closed-loop state model based on the plant state model.

%  Copyright
%  Charles L. Phillips  1994

clc
diary on
disp('             CLOSED-LOOP SYSTEM STATE MODEL')
disp(' ')
diary off
disp(' ')
kh=fpgk*fbghk;

if D~=0
diary on

   disp(' ')
   disp('  This program does not handle algebric loops, in which the D')
   disp('  matrix of the plant is nonzero.')
   disp(' ')
diary off
else

   if filterin ==1

      [adz,bdz,cdz,dddz]=tf2ss(ndz,ddz);
      orderdz=length(cdz);

   else

      adz=0; bdz=0; cdz=0; dddz=1;

   end

   ordergz=length(C);
   Ac11=A-kh*dddz*B*C;
   Ac12=fpgk*B*cdz;
   Ac21=-fbghk*bdz*C;
   Ac22=adz;
   Bc1=fpgk*dddz*B;
   Bc2=bdz;
   Cc1=C-kh*dddz*D*C;  Cc2=fpgk*D*cdz;
   Acl(1:ordergz,1:ordergz)= Ac11;
   Bcl(1:ordergz,1)=Bc1;
   Ccl(1,1:ordergz)=Cc1;
   Dcl=0;

   if filterin==1

      Acl(1:ordergz,ordergz+1:ordergz+orderdz)=Ac12;
      Acl(ordergz+1:ordergz+orderdz,1:ordergz)=Ac21;
      Acl(ordergz+1:ordergz+orderdz,ordergz+1:ordergz+orderdz)=Ac22;
      Bcl(ordergz+1:ordergz+orderdz,1)=Bc2;
      Ccl(1,ordergz+orderdz)=Cc2;
      Dcl=0;

   end

   disp(' ')
diary on
   disp('  The closed-loop system matrices are:')
   disp(' ')
   Acl
   disp(' ')
   Bcl
   disp(' ')
   Ccl
   disp(' ')
   Dcl
   disp(' ')
diary off
   disp('  Press any key to continue ...'); pause, clc
   disp(' ')
diary on
   disp('  The closed loop transfer function from the state matrices is:')
   [tnz,tdz]=ss2tf(Acl,Bcl,Ccl,Dcl);
   disp(' ')
   tnz
   disp(' ')
   tdz
   disp(' ')
diary off

end

disp('  Press any key to continue ...'); pause, clc

