%CLSMAA Closed-loop state model based on the plant state model.

%  Copyright
%  Charles L. Phillips  1994

clc
clear Ac11 Ac12 Ac21 Ac22 Bc1 Bc2 Cc1 Cc2 Acl Bcl Ccl Dcl 
clear Agcs Bgcs Ccgs Dgcs ordergps ordergcs

diary cl.dat
disp(' ')

disp('             CLOSED-LOOP SYSTEM STATE MODEL')
disp(' ')
disp(' ')
diary off
kh=fpgk*fbghk;

if D~=0

   disp(' ')
   disp('  This program does not handle algebric loops, in which the D')
   disp('  matrix of the plant is nonzero.')
   disp(' ')

else

   if filterin ==1

      [Agcs,Bgcs,Cgcs,Dgcs]=tf2ss(ngcs,dgcs);
      ordergcs=length(Cgcs);

   else

      Agcs=0; Bgcs=0; Cgcs=0; Dgcs=1;

   end

   ordergps=length(C);
   Ac11=A-kh*Dgcs*B*C;
   Ac12=fpgk*B*Cgcs;
   Ac21=-fbghk*Bgcs*C;
   Ac22=Agcs;
   Bc1=fpgk*Dgcs*B;
   Bc2=Bgcs;
   Cc1=C-kh*Dgcs*D*C;  Cc2=fpgk*D*Cgcs;
   Acl(1:ordergps,1:ordergps)= Ac11;
   Bcl(1:ordergps,1)=Bc1;
   Ccl(1,1:ordergps)=Cc1;
   Dcl=0;

   if filterin==1

      Acl(1:ordergps,ordergps+1:ordergps+ordergcs)=Ac12;
      Acl(ordergps+1:ordergps+ordergcs,1:ordergps)=Ac21;
      Acl(ordergps+1:ordergps+ordergcs,ordergps+1:ordergps+ordergcs)=Ac22;
      Bcl(ordergps+1:ordergps+ordergcs,1)=Bc2;
      Ccl(1,ordergps+1:ordergps+ordergcs)=Cc2;
      Dcl=0;

   end

diary cl.dat
disp(' ')
   disp(' ')
   disp('  The closed-loop system matrices are:')
   disp(' ')
   Acl
   disp(' ')
   Bcl
   disp(' ')
   Ccl
   disp(' ')
   Dcl
diary off
   disp('  Press any key to continue ...'); pause, clc
diary cl.dat
disp(' ')
   disp('  The closed loop transfer function     T(s) = tns/tds  is')
   disp('  from the state matrices:')
   [tns,tds]=ss2tf(Acl,Bcl,Ccl,Dcl);
   disp(' ')
   tns
   disp(' ')
   tds
   disp(' ')
   disp('  The eigenvalues of the closed-loop system matrix Acl are:')
   disp(' ')
   lambda = eig(Acl);
   lambda
   disp(' ')
   disp('  The time constants of the eigenvalues are:')
   disp(' ')
   ordercl=length(lambda);
   for ii=1:ordercl
      if real(lambda(ii)) == 0
         disp('        An eigenvalue is imaginary.')
      else
         tau = -1/real(lambda(ii))
      end
   end
   diary off

end

disp('  Press any key to continue ...'); pause, clc

