%CLSMANA Closed-loop state model based on open-loop state model.

%  Copyright
%  Charles L. Phillips  1994

diary cl.dat
disp(' ')

clc
disp('             CLOSED-LOOP SYSTEM STATE MODEL')
disp(' ')
diary off
disp(' ')
disp('             xdot(t) = Acl*x(t) + Bcl*u(t)')
disp(' ')
disp('                y(t) = Ccl*x(t) + Dcl*u(t)')
disp(' ')
disp(' ')
disp('  Press any key to continue ...'); pause
diary on
disp(' ')
disp('  The closed-loop system matrices are:')
disp(' ')
Acl = A - fpgk*fbghk*B*C
disp(' ')
Bcl = fpgk*B
disp(' ')
Ccl = C
disp(' ')
Dcl = D
diary off
disp(' ')
disp('  Press any key to continue ...'); pause
diary on
disp(' ')
disp('  The eigenvalues of the closed-loop system matrix Acl are:')
disp(' ')
lambda = eig(Acl)
disp(' ')
disp('  The time constants of the eigenvalues are:')
disp(' ')
ordercl=length(lambda);
for ii=1:ordercl
   if real(lambda(ii)) == 0
      disp('        An eigenvalue is imaginary.')
   else
      tau = -1/real(lambda(ii))
   end
end
diary off
disp(' ')
disp('  Press any key to continue ...'); pause, clc

