%ENGPMS Discrete plant model for digital control.

%  Copyright
%  Charles L. Phillips  1994

loop=1;  modelin=0;  filterin=0; momain=1; % flags
delete modl.dat
clc

disp('  Either the plant discrete transfer function or the plant discrete')
disp('  state model may be entered.')
disp(' ')

s=input(' Do you want to enter the state model [y/n]? ','s');
disp(' ')

if s=='y';

   disp(' ')
diary modl.dat
   disp('               PLANT DISCRETE STATE VARIABLE MODEL')
   disp(' ')
diary off
   disp(' ')
   disp('                    x(k + 1) = Ax(k) + Bu(k)')
   disp(' ')
   disp('                        y(k) = Cx(k) + Du(k)')
   disp(' ')
   T=input(' Enter the sample period T = ');
   disp(' ')
   order=input(' Enter the plant order = ');
   disp(' ')

   d0flag=1;
   abcdin
   D=0;

   disp(' ')
   disp('  Press any key to continue ...'), pause, clc
   disp(' ')
diary on
   disp('  The sample period T is:'); T
   disp(' ')
   disp('  The discrete plant matrices are:')
   disp(' ')
   A
   disp(' ')
   B
   disp(' ')
   C
   disp(' ')
   D
   disp(' ')
diary off
   disp('  Press any key to continue ...'); pause
   disp(' ')
diary on
   disp('  The numerator and denominator polynomials of the plant transfer ')
   disp('  function G(z) are:')
   disp(' ')
   [ngz,dgz]=ss2tf(A,B,C,0);
   ngz
   disp(' ')
   dgz

   disp(' ')
   disp('  The zeros of G(z) are:')
   disp(' ')
   z_plane_zeros=roots(ngz)
   disp(' ')
   disp('  The poles of G(z) are:')
   disp(' ')
   z_plane_poles=roots(dgz)
   disp(' ')
   if wplanefl==1
      diary on
      gz2gw
      diary off
   end

diary off
   disp('  Press any key to continue ...'); pause

else

   disp(' ')
diary modl.dat
   disp('             PLANT DISCRETE TRANSFER FUNCTION MODEL')
   disp(' ')
diary off
   disp(' ')
   T=input(' Enter the sample period T = ');
   disp(' ')
   order=input(' Enter the plant order = ');
   disp(' ')
   disp('     G(z) numerator = b(n)*z^n + b(n-1)*z^(n-1) + ...')
   disp(' ')
   disp('  Enter the numerator coefficients in descending order of n,')
   disp('  including the coefficients that are zero, with each coefficient')
   disp('  followed by pressing the enter key:')
   disp(' ')

   for ii=1:(order+1)
      jj=order+1-ii;
      jjj=int2str(jj);
      str1=['   b(',jjj,')= '];
      ngz(ii) = input(str1);
   end

   disp(' ')
   disp('    G(z) denominator = a(n)*z^n + a(n-1)*z^(n-1) + ...')
   disp(' ')
   disp('   Enter the denominator coefficients in descending order of n:')
   disp(' ')

   for ii=1:(order+1)
      jj=order+1-ii;
      jjj=int2str(jj);
      str1=['   a(',jjj,')= '];
      dgz(ii) = input(str1);
   end

   clc
diary on
   disp(' ')
   disp('  The sample period T is:'), disp(' ')
   T
   disp(' ')
   disp('  Plant transfer function:     G(z) = ngz/dgz')
   disp(' ')
   ngz
   disp(' ')
   dgz
   disp(' ')
   disp('  The zeros of G(z) are:')
   disp(' ')
   z_plane_zeros=roots(ngz)
   disp(' ')
   disp('  The poles of G(z) are:')
   disp(' ')
   z_plane_poles=roots(dgz)
   disp(' ')
diary off
   disp('  Press any key to continue ...'); pause

   %  G(z) to the discrete state model

   [A,B,C,D]=tf2ss(ngz,dgz);

   disp(' ')
diary on
   disp('  The plant discrete state matrices are:')
   disp(' ')
   A
   disp(' ')
   B
   disp(' ')
   C
   disp(' ')
   D
diary off

end

if wplanefl==1
diary on
   gz2gw
diary off
end
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the model data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print modl.dat
end
clc
disp(' ')
disp('  Press any key to return to menu.'), pause, clc


