%GS2GZ Discrete models from analog model.

%  Copyright
%  Charles L. Phillips  1994

loop=1; modelin=1; filterin=0; momain=0;
delete modl.dat
clc
disp('                   PLANT ANALOG MODEL')
disp(' ')
T=input(' Enter sample period T = ');
order=input(' Enter plant order = ');
disp(' ')
disp('  Either the plant analog transfer function or the plant analog state')
disp('  model may be entered.')
disp(' ')
s=input(' Do you want to enter the state model [y/n]? ','s');
disp(' ')

if s=='y';

   disp(' ')
diary modl.dat
   disp('                 PLANT ANALOG STATE-VARIABLE MODEL')
   disp(' ')
diary off
   disp(' ')
   disp('                     xdot(t) = Acx(t) + Bcu(t)')
   disp(' ')
   disp('                        y(t) = Cx(t) + Du(t)')
   disp(' ')
   disp(' ')

   d0flag=1;  %  D = 0
   abcdina
diary on
   disp(' ')
   disp('  The analog state matrices are:')
   disp(' ')
   Ac
   disp(' ')
   Bc
   disp(' ')
   C
   disp(' ')
   D
   disp(' ')
diary off
   disp('  Press any key to continue ...'), pause, clc
diary on
   disp('  The analog plant transfer function:      Gp(s) = ngs/dgs')
   [ngs,dgs]=ss2tf(Ac,Bc,C,D);
   disp(' ')
   ngs
   disp(' ')
   dgs
   disp(' ')
   disp('  The sample period T is:'), disp(' ')
   T
   disp(' ')
diary off
   disp('  Press any key to continue ...'), pause, clc

else

   disp(' ')
diary modl.dat
   disp('              PLANT ANALOG TRANSFER-FUNCTION MODEL')
   disp(' ')
diary off
   disp(' ')
   disp('  Gp(s) numerator = bc(n)*s^n + bc(n-1)*s^(n-1) + ...')
   disp(' ')
   disp('  Enter the numerator coefficients in descending order of n,')
   disp('  including coefficients that are zero, with each coefficient')
   disp('  followed by pressing the enter key:')
   disp(' ')

   for ii=1:(order+1)
      jj=order+1-ii;
      jjj=int2str(jj);
      str1=['    bc(',jjj,')= '];
      ngps(ii) = input(str1);
   end

   disp(' ')
   disp('  Gp(s) denominator = ac(n)*s^n + ac(n-1)*s^(n-1) + ...')
   disp('  Enter the denominator coefficients in descending order of n:')
   disp(' ')

   for ii=1:(order+1)
      jj=order+1-ii;
      jjj=int2str(jj);
      str1=['    ac(',jjj,')= '];
      dgps(ii) = input(str1);
   end

   clc
diary on
   disp('  The plant transfer function is:     Gp(s) = ngps/dgps')
   disp(' ')
   ngps
   disp(' ')
   dgps
   disp(' ')
   disp('  The sample period T is:'), disp(' ')
   T
   disp(' ')
diary off
   disp('  Press any key to continue ...'); pause

%  Gp(s) to the continuous state model

   [Ac,Bc,C,D]=tf2ss(ngps,dgps);

end

%  Continuous state model to the discrete state model

[A,B]=c2d(Ac,Bc,T);

disp(' ')
diary on
disp('  The discrete state matrices are:')
disp(' ')
A
disp(' ')
B
disp(' ')
C
disp(' ')
D
disp(' ')
diary off
disp('  Press any key to continue ...'); pause

%  discrete state model to G(z)

disp(' ')
diary on
disp('  The discrete plant transfer function:      G(z) = ngz/dgz')
[ngz,dgz]=ss2tf(A,B,C,D);
disp(' ')
ngz
disp(' ')
dgz
disp(' ')
disp('  The zeros of G(z) are:')
disp(' ')
z_plane_zeros=roots(ngz)
disp(' ')
disp('  The poles of G(z) are:')
disp(' ')
z_plane_poles=roots(dgz)
disp(' ')
diary off
disp('  Press any key to continue ...'); pause
disp(' ')

if wplanefl == 1
diary on
   gz2gw
end
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the model data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print modl.dat
end

disp(' ')
disp('  Press any key to return to menu.'); pause, clc


