%GSA Discrete models from analog model.

%  Copyright
%  Charles L. Phillips  1994

loop=1; modelin=1; filterin=0; momain=0;
clear A B C D ngps dgps order
delete modl.dat
clc

disp('                   PLANT ANALOG MODEL')
disp(' ')
order=input(' Enter plant order = ');
disp(' ')
disp('  Either the plant analog transfer function or the plant analog state')
disp('  model may be entered.')
disp(' ')
s=input(' Do you want to enter the state model [y/n]? ','s');
disp(' ')

if s=='y';

diary modl.dat
   disp(' ')
   disp('                 PLANT ANALOG STATE-VARIABLE MODEL')
diary off
   disp(' ')
   disp(' ')
   disp('                     xdot(t) = Ax(t) + Bu(t)')
   disp(' ')
   disp('                        y(t) = Cx(t) + Du(t)')
   disp(' ')
   disp(' ')

   d0flag=1;  %  D = 0
   abcdin

diary on
   disp(' ')
   disp('  The analog state matrices are:')
   disp(' ')
   A
   disp(' ')
   B
   disp(' ')
   C
   disp(' ')
   D
   disp(' ')
diary off
   disp('  Press any key to continue ...'), pause, clc
diary on
   disp('  The analog plant transfer function:      Gp(s) = ngps/dgps')
   [ngps,dgps]=ss2tf(A,B,C,D);
   disp(' ')
   ngps
   disp(' ')
   dgps
diary off
   disp(' ')
   disp('  Press any key to continue ...'), pause
diary on
   disp(' ')
   disp('  The zeros of Gp(s) are:')
   disp(' ')
   s_plane_zeros=roots(ngps)
   disp(' ')
   disp('  The poles of Gp(s) are:')
   disp(' ')
   s_plane_poles=roots(dgps)
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the model data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print modl.dat
end
clc

else

diary modl.dat
   disp(' ')
   disp('              PLANT ANALOG TRANSFER-FUNCTION MODEL')
   disp(' ')
diary off
   disp(' ')
   disp('  Gp(s) numerator = b(n)*s^n + b(n-1)*s^(n-1) + ...')
   disp(' ')
   disp('  Enter the numerator coefficients in descending order of n,')
   disp('  including coefficients that are zero, with each coefficient')
   disp('  followed by pressing the enter key:')
   disp(' ')

   for ii=1:(order+1)
      jj=order+1-ii;
      jjj=int2str(jj);
      str1=['    b(',jjj,')= '];
      ngps(ii) = input(str1);
   end

   disp(' ')
   disp('  Gp(s) denominator = a(n)*s^n + a(n-1)*s^(n-1) + ...')
   disp('  Enter the denominator coefficients in descending order of n:')
   disp(' ')

   for ii=1:(order+1)
      jj=order+1-ii;
      jjj=int2str(jj);
      str1=['    a(',jjj,')= '];
      dgps(ii) = input(str1);
   end

   clc
diary on
   disp('  The plant transfer function is:     Gp(s) = ngps/dgps')
   disp(' ')
   ngps
   disp(' ')
   dgps
diary off
   disp(' ')
   disp('  Press any key to continue ...'), pause
diary on
   disp(' ')
   disp('  The zeros of Gp(s) are:')
   disp(' ')
   s_plane_zeros=roots(ngps)
   disp(' ')
   disp('  The poles of Gp(s) are:')
   disp(' ')
   s_plane_poles=roots(dgps)
diary off
   disp(' ')
   disp('  Press any key to continue ...'); pause


%  Gp(s) to the continuous state model

   [A,B,C,D]=tf2ss(ngps,dgps);

diary on
   disp(' ')
   disp('  The state matrices are:')
   disp(' ')
   A
   disp(' ')
   B
   disp(' ')
   C
   disp(' ')
   D
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the model data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print modl.dat
end
clc

end

disp(' ')
disp('  Press any key to return to menu.'); pause, clc


