%KAL Kalman filter.

%  Copyright
%  Charles L. Phillips  1994

delete kalf.dat
clc
clear G
%        Flags
preest=0; curest=0; roeest=0; kalest=1;
diary kalf.dat
disp('                             KALMAN FILTER DESIGN')
disp(' ')
diary off
disp(' ')
disp('  The plant is described by:')
disp(' ')
disp('                      x(k + 1) = Ax(k) + Bu(k) + B1*w(k)')
disp(' ')
disp('                          y(k) = Cx(k) + v(k)')
disp(' ')
disp('  where the covariances are given by:')
disp(' ')
disp('                cov[w(j),w(k)] = Rw*djk')
disp(' ')
disp('                cov[v(j),v(k)] = Rv*djk')
disp(' ')
disp('  and djk is the Kronecker delta function.')
disp(' ')
disp('  The state estimator is described by:')
disp(' ')
disp('                      q(k + 1) = Fq(k) + Gy(k + 1) + Hu(k)')
disp(' ')
disp('  where F = (A - G(k)CA).'), disp(' ')
disp('  Press any key to continue ...'), pause, clc
disp(' ')
disp('  Enter the B1-vector elements, with each element followed by')
disp('  pressing the enter key:')
disp(' ')

for ii=1:order
   iii=int2str(ii);
   str1=['   B1(',iii,')= '];
   B1(ii,1) = input(str1);
end

disp(' ')
Rw=input('               Enter:     Rw = ');
disp(' ')
Rv=input('               Enter:     Rv = ');
disp(' ')
disp('  Enter the number of sample periods in run:')
N=input(' Number of sample periods = ');
disp(' ')
disp('  Enter the initial error covariance matrix M(0) by rows, with each') 
disp('  element followed by pressing the enter key:')

   for ii=1:order
      for jj=1:order
      iii=int2str(ii);
      jjj=int2str(jj);
      str1=['   M(',iii,',',jjj,')= '];
      M(ii,jj) = input(str1);
      end
   end

disp(' ')
disp('  Press any key to continue ...'),disp(' '), pause
diary on
B1
disp(' ')
Rw
disp(' ')
Rv
disp(' ')
disp('  The M(0) matrix is:')
disp(' ')
M
disp(' ')
diary off
disp('  Press any key to continue ...'), pause
count=3;
disp(' ')
diary on
disp('  Iteration        Gains')
disp(' ')

for n=1:N
   GG = M*C'*inv(C*M*C' + Rv);
   GG1(n)=GG(1);

   if order>=2
      GG2(n)=GG(2);
   end

   P=M-GG*C*M;
   M=A*P*A'+B1*Rw*B1';
   [n,GG']
   if count==11
      disp(' ')
diary off
      disp('  Press any key to continue ...'),disp(' '), pause
diary on
      count=0;
   end

   count=count+1;
end

disp(' ')
disp('  Press any key to continue ...'); pause
disp(' ')
diary on
disp('  The final value of the P matrix is:')
disp(' ')
P
disp(' ')
diary off
disp('  Press any key for a plot of the gains.'); pause, clc
jj=0:1:(N-1);
subplot(111), plot(jj,GG1,'-',jj,GG2,'+')
title('Kalman gains G(1) (solid line) and G(2) (+)')
xlabel('Time')
grid
pause
G=GG;
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print kalf.dat
   clc
end

disp(' ')
disp('  Press any key to return to the menu. '),pause; clc


