%LOCUSD Root locus, discrete.

%  Copyright
%  Charles L. Phillips  1994

delete rl.dat
clc
clear K
disp('  This program calculates a root locus for a system with the')
disp('  open-loop function KG(z)Hk or KG(w)Hk, where K is the variable')
disp('  gain, G is the plant transfer function, and Hk is the constant')
disp('  sensor gain.')
disp(' ')
fbghk=input(' Enter the sensor gain Hk = ');
disp(' ')
disp('  The gain K is varied from Kmin to Kmax with the number')
disp('  of increments N.')
Kmin = input(' Enter the minimum gain value Kmin = ');
Kmax = input(' Enter the maximum gain value Kmax = ');
N = input(' Enter the number of increments N = ');
disp(' ')
disp('  OPTIONS:')
disp(' ')
disp('        1.  z-plane root locus')
disp(' ')
disp('        2.  w-plane root locus')
disp(' ')
q22=input(' Enter 1, or 2:  ');
if q22==1
   num= ngz;
   den=dgz;
elseif q22==2
   num=ngw;
   den=dgw;
end
disp(' ')
disp('  Press any key to continue ...'), pause, clc
diary rl.dat
orderrl = order;
if q22 == 1
   disp('                 Z-PLANE ROOT LOCUS ')
elseif q22 == 2
   disp('                 W-PLANE ROOT LOCUS ')
end
Hk = fbghk
brkptsp
disp('  The roots r and the corresponsing gain K are:')

disp(' ')
delK=(Kmax-Kmin)/N;
count=0;
prtcnt=fix(22/(order+3));
for ii=1:(N+1)
   iii=ii-1;
   K=Kmin+delK*iii;
   p=den+K*num;
   r=roots(p);
   K
   r
   count=count+1;
   if count==prtcnt
diary off
      disp('  Press any key to continue ...'), pause
diary on
      count=0;
   end  
   for jj=1:order
      jjj=iii*order+jj;
      rts(jjj) =r(jj);
   end
end
diary off
disp('  Press any key to continue ...'), pause
plot(rts,'x')
pause, clc
clear num den 
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the root locus data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print rl.dat
end
clc

disp(' ')
disp('  Press any key to continue ...'), pause, clc


