%LOCUSRA Root locus, analog.

%  Copyright
%  Charles L. Phillips  1994

delete rl.dat
clc
clear K
diary rl.dat
disp('                       ROOT LOCUS  ')
disp(' ')
diary off
disp(' ')
disp('  This program calculates a root locus for a system with the')
disp('  plant transfer function Gp(s), the variable gain K, and the')
disp('  constant sensor gain Hk.  A compensator with the transfer')
disp('  function Gc(s) may be included.')
disp(' ')
fbghk=input(' Enter the sensor gain Hk = ');
disp(' ')
disp('  The gain K is varied from Kmin to Kmax with the number')
disp('  of increments N.')
Kmin = input(' Enter the minimum gain value Kmin = ');
Kmax = input(' Enter the maximum gain value Kmax = ');
N = input(' Enter the number of increments N = ');
clc

q22 = 1;
if filterin==1
   disp('  OPTIONS:')
   disp(' ')
   disp('        1.  Root locus for uncompensated system')
   disp(' ')
   disp('        2.  Root locus for compensated system')
   disp(' ')
   q22=input(' Enter 1, or 2:  ');
end
if q22==1
   orderrl=order;
   num= fbghk*ngps;
   den=dgps;
elseif q22==2
   orderrl=order+orderfl;
   num=fbghk*conv(ngcs,ngps);
   den=conv(dgps,dgcs);
end
disp(' ')
disp('  Press any key to continue ...'), pause, clc
diary rl.dat
disp(' ')
Hk = fbghk

brkptsp
disp('  The gain K and the corresponding roots r  are:')

disp(' ')
delK=(Kmax-Kmin)/N;
count=0;
prtcnt=fix(22/(order+3));
for ii=1:(N+1)
   iii=ii-1;
   K=Kmin+delK*iii;
   p=den+K*num;
   r=roots(p);
   K
   r
   count=count+1;
diary off
   if count==prtcnt
      disp('  Press any key to continue ...'), pause
      count=0;
   end  
diary on
   for jj=1:order
      jjj=iii*order+jj;
      rts(jjj) =r(jj);
   end
end
diary off
disp('  Press any key to continue ...'), pause
plot(rts,'x')
pause, clc
clear num den 
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the root-locus data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print rl.dat
end
clc

disp('  Press any key to continue ...'), pause, clc


