%LQ Linear quadratic optimal design.

%  Copyright
%  Charles L. Phillips  1994

delete liqu.dat
clc
clear K iji KK1 KK2 KK3 KK
%    Flags
lqdes=1; poleas=0;
diary liqu.dat
disp('                    LINEAR QUADRATIC OPTIMAL DESIGN')
disp(' ')
diary off
disp(' ')
disp('  The plant is described by:')
disp(' ')
disp('                        x(k + 1) = Ax(k) + Bu(k)')
disp(' ')
disp('  The feedback law is described by: ')
disp(' ')
disp('                            u(k) = -K(k)x(k)')
disp(' '), 
disp('  where the gain matrix K is calculated.  The closed-loop equations')
disp('  are:')
disp(' ')
disp('                        x(k + 1) = [A - B*K(k)]x(k)')
disp(' ')
disp('  The cost function J that is minimized is given by:')
disp(' ')
disp('                 J = SUM [ xt(k)*Q*x(k) + R*(u(k))^2 ]')
disp(' ')
disp('  Enter the Q matrix by rows, with each element followed by pressing')
disp('  the enter key:')
disp(' ')

   for ii=1:order
      for jj=1:order
         iii=int2str(ii);
         jjj=int2str(jj);
         str1=['   Q(',iii,',',jjj,')= '];
         Q(ii,jj) = input(str1);
      end
   end

disp(' ')
disp('  Enter R:')
R=input('   R = ');
disp(' ')
disp('  Enter the number of sample periods N in this run:')
N=input('   N = ');
disp(' ')
diary on
disp(' ')
Q
disp(' ')
R
disp(' ')
diary off
disp('  Press any key to continue ...'),disp(' '), pause
diary on
P=Q;
count=3;
disp(' ')
disp('Iteration        Gains')

for n=1:N
   KK = inv(B'*P*B + R)*B'*P*A;
   KK1(n)=KK(1);

   if order>=2
      KK2(n)=KK(2);
   end

   if order>=3
      KK3(n)=KK(3);
   end

   P1=A'*P*(A - B*KK) + Q;
   P=P1;
   iji(n) = N-n+1;
   [iji(n),KK]

   if count==10
diary off
      disp('  Press any key to continue ...'),disp(' '), pause
      count=0;
      disp('Iteration        Gains')
diary on
   end  

   count=count+1;
end
disp(' ')
diary off
disp('  Press any key to continue ...'); pause
disp(' ')
diary on
disp('  The final value of the P matrix is:')
disp(' ')
P
disp(' ')
diary off
disp('  Press any key for a plot of the gains.'); pause
subplot(111), plot(iji,KK1')
title('LQ gains K(1) (solid line)  K(2) (+)  K(3) (*)')
grid
hold on

if order > 1
   plot(iji,KK2','+')
end

if order > 2
   plot(iji,KK3','*')
end
hold off

pause, clc
K=KK;
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print liqu.dat
   clc
end

disp(' ')
disp('  Press any key to return to the menu.'),pause; clc


