%MATCAL Polynomial manipulations.

%  Copyright
%  Charles L. Phillips  1994

clc
clear A B C D
loop3=1;   % loop3 = 0 exits this menu
while loop3==1
   disp('  OPTIONS: ')
   disp(' ')
   disp('        1.  Calculate the inverse of a square matrix')
   disp(' ')
   disp('        2.  Calculate the determinant of a square matrix')
   disp(' ')
   disp('        3.  Calculate the eigenvalues and eigenvectors of ')
   disp('            a square matrix')
   disp(' ')
   disp('        4.  Calculate the product of two matrices')
   disp(' ')
   disp('        5.  Exit this menu')
   disp(' ')

   q4=input(' Enter integer choice:  ');
   if q4 == 1

      %  matrix inverse

      delete mx.dat
      clc
      clear A B
      disp(' ')
      diary mx.dat
      disp('                   MATRIX INVERSE')
      disp(' '), disp(' ')
      diary off
      disp(' ')
      disp('  Given the square matrix A, this program calculates')
      disp('  B = inverse(A).')
      inputap
      diary on
      disp(' ')
      disp('  The matrix entered:')
      disp(' ')
      A
      disp(' ')
      diary off
      disp('  Press any key to continue ...'), pause
      diary on
      disp(' ')
      disp('  B = inverse(A):')
      disp(' ')
      B = inv(A)
      disp(' ')
      diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
      s=input(' Do you want the results printed? [y/n]: ','s');
      if s=='y'
         ! copy iden.dat prn:
         ! print mx.dat
      end
      clc

      disp('  Press any key to continue ...'), pause, clc
   
   elseif q4 == 2

      %  matrix determinant

      clear A
      delete mx.dat
      clc
      disp(' ')
      diary mx.dat
      disp('                MATRIX DETERMINANT')
      disp(' '), disp(' ')
      diary off
      disp('  Given the square matrix A, this program calculates')
      disp('  detA = determinant of A.')
      inputap
      disp(' ')
      disp('  The matrix entered:')
      disp(' ')
diary on
      A
      disp(' ')
diary off
      disp('  Press any key to continue ...'), pause
      disp(' ')
diary on
      disp('  detA = determinant(A):')
      disp(' ')
      detA = det(A)
      disp(' ')
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
      s=input(' Do you want the results printed? [y/n]: ','s');
      if s=='y'
         ! copy iden.dat prn:
         ! print mx.dat
      end
      clc

      disp('  Press any key to continue ...'), pause, clc

   elseif q4 == 3

      %  matrix eigenvalues and eigenvectors

      clear A V D
      delete mx.dat
      clc
      disp(' ')
      diary mx.dat
      disp('          MATRIX EIGENVALUES AND EIGENVECTORS')
      disp(' '), disp(' ')
      diary off
      disp('  Given the square matrix A, this program calculates')
      disp('  the eigenvalues (characteristic values) and the')
      disp('  eigenvectors (characteristic vectors) of A.')
      inputap
      disp(' ')
      disp('  The matrix entered:')
      disp(' ')
diary on
      A
      disp(' ')
diary off
      disp('  Press any key to continue ...'), pause, clc
      disp(' ')
      [V,D]=eig(A);
      disp(' ')
diary on
      disp('  Eigenvalues of A are the diagonal elements of the matrix D:')
      disp(' ')
      D
      disp(' ')
    disp('  The corresponding eigenvectors are the columns of the matrix V:')
      disp(' ')
      V
      disp(' ')
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
      s=input(' Do you want the results printed? [y/n]: ','s');
      if s=='y'
         ! copy iden.dat prn:
         ! print mx.dat
      end
      clc

      disp('  Press any key to continue ...'), pause, clc

   elseif q4 == 4
      %  product of matrices

      clear A B C
      delete mx.dat
      clc
      disp(' ')
      diary mx.dat
      disp('                    MATRIX PRODUCT')
      disp(' '), disp(' ')
      diary off
      disp('  Given the matrices A and B, this program calculates')
      disp('  the product C = A*B .  The number of columns of A must')
      disp('  equal the number of rows of B.')
      inputans
      disp(' ')
      disp('  The matrices entered:')
      disp(' ')
diary on
      A
      disp(' ')
      B
      disp(' ')
diary off
      disp('  Press any key to continue ...'), pause
      disp(' ')
diary on
      disp('  C = A*B')
      disp(' ')
      C = A*B
      disp(' ')
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
      disp('  Press any key to continue ...'), pause, clc
      s=input(' Do you want the results printed? [y/n]: ','s');
      if s=='y'
         ! copy iden.dat prn:
         ! print mx.dat
      end
      clc

   elseif q4 == 5

      loop3=0;

   end

end
clc
