%NQU Nyquist diagram for a discrete system.

%  Copyright
%  Charles L. Phillips  1994

delete nyq.dat
clc
diary nyq.dat
disp('                       NYQUIST DIAGRAM ')
disp(' ')
diary off
ndgw=ngw;
ddgw=dgw;

if filterin ==1
   disp(' ')
   disp('     1.  Nyquist diagram for K*G(z)*Hk')
   disp(' ')
   disp('     2.  Nyquist diagram for K*G(z)*D(z)*Hk')
   q1=input('  Enter 1 or 2: ');

   if q1==2
      ndgw=conv(ngw,ndw);
      ddgw=conv(dgw,ddw);
   end

end

disp(' ')
disp('   Enter the forward path gain K and the sensor gain Hk')
fpgk=input('           gain K = ');
fbghk=input('          gain Hk = ');
disp(' ')
disp('   Enter w-plane frequency range: wwi <= ww <= wwf  with n increments.')
wwi=input('                 Initial value  wwi = ');
wwf=input('                   Final value  wwf = ');
nn=input('   Number of increments in range  n = ');
inc=(wwf-wwi)/nn;
ww=wwi:inc:wwf;
w=2/T*atan(ww*T/2);
nkdghw=fpgk*fbghk*ndgw;
[re,im,ww]=nyquist(nkdghw,ddgw,ww);
gofw=re+j*im;
gofwmag=abs(gofw);
phasegw=angle(gofw)*180/pi;
diary on
disp(' ')
K = fpgk
Hk = fbghk
disp(' ')
disp('          Frequency Response: OLF = Open-Loop Function            ')
disp(' ')
disp(' omegaw  omega  Re OLF(jww)  Im OLF(jww)  mag OLf(jww)  arg OLF(jww)')
pr=length(ww);  count=3;

for i=1:pr
   [ww(i), w(i),re(i),im(i),gofwmag(i),phasegw(i)]
diary off
   if count==10
      disp(' '), disp('Press any key to continue ...'),disp(' '), pause
disp(' omegaw  omega  Re OLF(jww)  Im OLF(jww)  mag OLF(jww)  arg OLF(jww)')
      count=0;

   end  
diary on
   count=count+1;

end
diary off
disp(' ')
disp('   Press any key for a plot of the Nyquist diagram.'); pause
subplot(111), plot(re,im)
title('Nyquist Diagram'); xlabel('Re G(jww)');
ylabel('Im G(jww)'); grid
pause, clc
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the frequency-response data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print nyq.dat
end
clc


