%NQUA Nyquist diagram for an analog system.

%  Copyright
%  Charles L. Phillips  1994

delete nyq.dat
clc
diary nyq.dat
disp('                       NYQUIST DIAGRAM ')
disp(' ')
diary off
ngols=ngps;
dgols=dgps;

if filterin ==1
   disp(' '), disp(' ')
   disp('     1.  Nyquist diagram for K*G(s)*Hk')
   disp(' ')
   disp('     2.  Nyquist diagram for K*G(s)*Gc(s)*Hk')
   q1=input('  Enter 1 or 2: ');

   if q1==2
      ngols=conv(ngps,ngcs);
      dgols=conv(dgps,dgcs);
   end

end

disp(' ')
disp('   Enter the forward path gain K and the sensor gain Hk')
fpgk=input('           gain K = ');
fbghk=input('          gain Hk = ');
disp(' ')
disp('   Enter the frequency range: wi <= w <= wf  with n increments.')
wi=input('                 Initial value  wi = ');
wf=input('                   Final value  wf = ');
nn=input('   Number of increments in range  n = ');
inc=(wf-wi)/nn;
w=wi:inc:wf;
ngols=fpgk*fbghk*ngols;
[re,im,w]=nyquist(ngols,dgols,w);
golw=re+j*im;
golwmag=abs(golw);
phasegw=angle(golw)*180/pi;
diary nyq.dat
disp(' ')
K = fpgk
Hk = fbghk
disp(' ')
disp('          Frequency Response: OLF = Open-Loop Function            ')
disp(' ')
disp('  omega   Re OLF(jw)  Im OLF(jw)  mag OLf(jw)  arg OLF(jw)')
pr=length(w);  count=3;

for i=1:pr
   [w(i),re(i),im(i),golwmag(i),phasegw(i)]
diary off
   if count==10
      disp(' '), disp('Press any key to continue ...'),disp(' '), pause
      disp('  omega   Re OLF(jw)  Im OLF(jw)  mag OLf(jw)  arg OLF(jw)')
      count=0;

   end  
diary on
   count=count+1;

end
diary off
disp(' ')
disp('   Press any key for a plot of the Nyquist diagram.'); pause
subplot(111), plot(re,im)
title('Nyquist Diagram'); xlabel('Re Gol(jw)');
ylabel('Im Gol(jw)'); grid
pause, clc
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the frequency-response data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print nyq.dat
end
clc


