%NUINNIA Numerical integration, Euler's or fourth-order Runge-Kutta.

%  Copyright
%  Charles L. Phillips  1994

delete tr.dat
clc
clear tm time1 x xdot x1 x2
Acl = ACL;
% iterative solution
ordercl = length(Acl);
Bcl = zeros(ordercl,1);
x = zeros(ordercl,1);
count=3;
diary tr.dat
disp('                CLOSED-LOOP SYSTEM TIME RESPONSE')
disp(' ')
diary off
disp(' ')
disp('  The system response is calculated by numerical integration for ')
disp('  0 < t < tf, with the numerical-integration increment H.')
disp(' ')
tf=input('                       Final time tf = ');
disp(' ')
H=input('   Numerical integration increment H = ');
iter=ceil(tf/H) + 1;
disp(' ')
disp('  Choose the numerical-integration procedure to be used:')
disp(' ')
disp('       1.  Euler method')
disp(' ')
disp('       2.  4th-order Runge-Kutta method')
disp(' ')
intcho=input(' Enter 1 or 2:  ');
disp(' ')
disp('  Enter the initial conditions in the order of x1(0), x2(0), ... :')

for ii=1:ordercl
   iii=int2str(ii);
   str1=['    x',iii,'(0)= '];
   x(ii) = input(str1);
end
disp(' ')
diary on
H
disp(' ')
disp('             SYSTEM STATES')
disp(' ')
disp('   time       x1(t)     x2(t)    ...')
u = 0;
for k=1:iter

   tm=(k-1)*H;

   [tm,x']
   time1(k)=tm;

   x1(k) = x(1);
   if ordercl > 1
      x2(k) = x(2);
   end

   if count==11
diary off
      disp(' ')
      disp('  Press any key to continue ...'),disp(' '), pause
      count=0;
diary on
   end  

   count=count+1;

   if intcho==1
      xdot = Acl*x;
      x = x + H*xdot;

   elseif intcho==2
      k1=0;k2=0;k3=0;w=0;theta=0;
      runge4a
   end

end
diary off
disp(' ')
disp('  Press any key for a plot of the outputs.'); pause,clc
subplot(111), plot(time1,x1)
title('Time Response x1(t), x2(t) *')
xlabel('Time')
ylabel('Amplitude')
grid
if ordercl > 1
   hold on
   plot(time1,x2,'*')
   hold off
end
pause
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the time-response data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print tr.dat
end
clc


