%NUMINTA Numerical integration by Euler's or fourth-order Runge-Kutta.

%  Copyright
%  Charles L. Phillips  1994

clear y tm time1 y1 u1
% iterative solution
iter=ceil(tf/H) + 1;
x=x1';
count=3;
diary tr.dat
disp(' ')
K = fpgk
Hk = fbghk
H
disp(' ')
disp('          SYSTEM TIME RESPONSE')
disp(' ')
disp('   time     input     y(t) ')

for k=1:iter

   tm=(k-1)*H;

   calinpa

   y = Ccl*x + Dcl*u;
   [tm,u,y]
   time1(k)=tm;

   y1(k)=y;
   u1(k)=u;
   if count==11
diary off
      disp(' ')
      disp('  Press any key to continue ...'),disp(' '), pause
      count=0;
diary on
   end  

   count=count+1;

   if intcho==1
      xdot = Acl*x + Bcl*u;
      x = x + H*xdot;

   elseif intcho==2
      runge4a
   end

end
diary off
disp(' ')
disp('  Press any key for a plot of the outputs.'); pause,clc
subplot(111), plot(time1,y1)
title('Time Response y(t) with u(t) *')
xlabel('Time')
ylabel('y(t)')
grid
hold on
plot(time1,u1,'*')
hold off
pause
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the time-response data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print tr.dat
end
clc


