%PARFE Partial-fraction expansion procedures.

%  Copyright
%  Charles L. Phillips  1994

delete pfe.dat
clc
clear num den r p k z order m n
disp('  This program performs a partial-fraction expansion of the rational')
disp('  function F(s), recombines a partial-fraction expansions into a')
disp('  rational function, and calculates a rational function from its')
disp('  poles and zeros.')
disp(' ')
disp('  OPTIONS:')
disp(' ')
disp('         1.  Partial-fraction coefficients calculated')
disp(' ')
disp('         2.  Partial-fraction terms recombined')
disp(' ')
disp('         3.  Rational fuction from its poles and zeros')
disp(' ')
qq2=input(' Enter integer choice:  ');
clc

if qq2 == 1

diary pfe.dat
   disp(' ')
   disp('             PARTIAL-FRACTION EXPANSION')
   disp(' ')
   disp(' ')
   disp('                for F(s) = num/den')
   disp(' ')
diary off
   disp('  The denominator of F(s) is')
   disp(' ')
   disp('     den(n)*s^n + den(n-1)*s^(n-1) + ... + den(1)*s + den(0)')
   disp(' ')
   disp('  The numerator is similarily defined with coefficients num(i)')
   order = input('  Enter the order of the denominator polynomial: ');
   disp(' ')
   disp('  Enter the numerator polynomial coefficients as requested:')
   innum
   disp(' ')
   disp('  Enter the denominator polynomial coefficients as requested:')
   inden
   disp(' ')
   disp('  The data as entered are:')
   disp(' ')
diary on
   order
   num
   den
diary off
   disp(' ')
   disp('  Press any key to continue ...'), pause, clc
diary on
   disp(' ')
   disp('  r = partial-fraction coefficients, p = poles, k = num(n)/den(n)')
   disp(' ')
   [r,p,k] = residue(num,den);
   disp('   Residue    Pole')
   disp(' ')
   [r,p]
   disp(' ')
   k
diary off
   disp(' ')
   disp('  Press any key to continue ...'), pause, clc

elseif qq2 == 2
   disp('  This option not implemented - problems with MATLAB')

%diary pfe.dat
%   disp(' ')
%   disp('            PARTIAL-FRACTION RECOMBINATION')
%   disp(' ')
%   disp('  The partial-fraction expansion of F(s) is of the form')
%   disp(' ')
%   disp('    F(s) = r1/(s-p1) + r2/(s-p2) + ... + rn/(s-pn) + k')
%   disp(' ')
%   disp('  This program converts this sum to the rational function')
%   disp(' ')
%   disp('      F(s) =  num/den')
%   disp(' ')
%diary off
%   n = input(' Enter the order of the denominator polynomial n = ');
%   disp(' ')
%   disp('  Enter the residues ri and poles pi as requested:')
%   for ii=1:n
%      iii=int2str(ii);
%      str1=['r',iii,' = '];
%      r(ii,1) = input(str1);
%      str2=['   p',iii,' = '];
%      p(ii,1) = input(str2);
%   end
%   k = input('   Enter k = ')
%   disp('  The data as entered are:')
%diary on
%   disp(' ')
%   n
%   k
%   disp('  The residues with the corresponding poles are:')
%   disp('  Residues   Poles')
%   [r,p]
%   disp(' ')
%diary off
%   disp('  Press any key to continue ...'), pause, clc
%   disp('  num is the numerator coefficients, and den are those of')
%   disp('  the denominator:')
%   disp(' ')
%   [num,den] = residue(r,p,k);
%diary on
%   num
%   den
%diary off
   disp(' ')
   disp('  Press any key to continue ...'), pause, clc

elseif qq2 == 3

diary pfe.dat
   disp(' ')
   disp('        RATIONAL FUNCTION FROM ITS ZEROS AND POLES')
   disp(' ')
diary off
   disp('  The numerator of F(s) has the zeros z(i) and is of the form')
   disp(' ')
   disp('      num = k*[s-z(1)]*[s-z(2)]*...*[(s-z(m)]')
   k = input('  Enter the value k = ');
   m = input('  Enter the number of zeros of F(s) [or F(z)] m = ');
   disp(' ')
   if m == 0
      num = k;
   else
      disp('  Enter the zeros z(i)')
      for ii=1:m
         iii=int2str(ii);
         str1=['   z(',iii,') = '];
         z(ii) = input(str1);
      end
      num=k*poly(z);
   end

   disp(' ')
   disp('  The denominator of F(s) has the poles p(i) and is of the form')
   disp(' ')
   disp('      den = [s-p(1)]*[s-p(2)]*...)[(s-p(n)]')
   n = input('  Enter the number of poles of F(s) n = ');
   disp(' ')
   disp('  Enter the poles p(i):')
   for ii=1:n
      iii=int2str(ii);
      str1=['   p(',iii,') = '];
      p(ii) = input(str1);
   end
   den=poly(p);
   disp(' ')
   disp('  The data as entered are:')
   disp(' ')
diary on
   k
   if m == 0
   else
      z
   end
   p
   disp(' ')
diary off
   disp('  Press any key to continue ...'), pause, clc
diary on
   disp('  The ration function is F(s) =  num/den, where num are the')
   disp('  numerator coefficients, and den are those of the denominator:')
   disp(' ')
   num
   den
diary off
   disp(' ')
   disp('  Press any key to continue ...'), pause, clc

end
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input('  Do you want the results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print pfe.dat
end
clc


