%PESA State estimator, analog systems.

%  Copyright
%  Charles L. Phillips  1994

delete pres.dat
clc
clear G ale
%        Flags
preest=1; curest=0; roeest=0; kalest=0;
diary pres.dat
disp('                         STATE ESTIMATOR DESIGN')
disp(' ')
diary off
disp(' ')
disp('  The plant is described by:')
disp(' ')
disp('                          xdot(t) = Ax(t) + Bu(t)')
disp(' ')
disp('                             y(t) = Cx(t)')
disp(' ')
disp('  The state estimator is described by: ')
disp(' ')
disp('                         x^dot(t) = Fx^(t) + Gy(t) + Bu(t)')
disp(' '), 
disp('  where F = (A - GC).  x^(t) are the extimator states')
disp(' ')
disp('  Press any key to continue ...'), pause
disp(' ')
disp('  The desired state-estimator characteristic equation is of the form,')
disp('  with ale(n) = 1:')
disp(' ')
disp('    ale(n)*s^n + ale(n -1)*s^(n - 1) + ... + ale(1)*s + ale(0) = 0')
disp(' ')
disp('  Enter the characteristic-equation coefficients in descending order')
disp('  of n, with each coefficient followed by pressing the enter key.')

for ii=1:(order+1)
   iii=order + 1 - ii;
   iiii=int2str(iii);
   str1=['   ale(',iiii,')= '];
   ale(ii) = input( str1);
end

disp(' ')
diary on
disp('  The characteristic-equation coefficients are:')
disp(' ')
ale
AMC=C;
AMCT=AMC;

for n=2:order
   AMCT=AMCT*A;

   for nn=1:order
      AMC(n,nn)=AMCT(1,nn);
   end

end

AMCI=inv(AMC);
CC=polyvalm(ale,A);
CCC = CC*AMCI;
disp(' ')
disp('  The gain matrix G is:')
disp(' ')
G=CCC(:,order)
disp(' ')
diary off
disp('  Press any key to continue ...'), pause
diary on
disp(' ')
disp('  The closed-loop estimator matrix AG = (A - GC) is:')
disp(' ')
AG=A-G*C
disp(' ')
diary off
disp('  Press any key to continue ...'), pause
disp(' ')
diary on
disp('  For verifcation, the closed-loop characteristic equation')
disp('  coefficients, calculated from AG, are:')
disp(' ')
ale=poly(AG)
disp(' ')
disp('  The estimator characteristic-equation roots in rectangular form')
disp('  are:')
disp(' ')
r=roots(ale)
disp(' ')
disp('  The estimator characteristic-equation roots in polar form are:')
disp(' ')
magr=abs(r); angler=angle(r)*180/pi;
[magr,angler]
diary off
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print pres.dat
   clc
end

disp(' ')
disp('  Press any key to return to the menu.'), pause, clc


