%PPD Pole-placement design, discrete systems.

%  Copyright
%  Charles L. Phillips  1994

delete popa.dat
clc
clear K
clear alc
%    Flags
poleas=1; lqdes=0;
diary popa.dat
disp('                           POLE-PLACEMENT DESIGN ')
disp(' ')
diary off
disp(' ')
disp('  The plant is described by:')
disp(' ')
disp('                         x(k + 1) = Ax(k) + Bu(k)')
disp(' ')
disp('  The feedback law is described by:')
disp(' ')
disp('                             u(k) = -Kx(k)')
disp(' '), 
disp('  where the gain matrix K is calculated.  The closed-loop equations')
disp('  are.')
disp(' ')
disp('                         x(k + 1) = [A - BK]x(k)')
disp(' ')
disp('  Press any key to continue ...'), pause
disp(' ')
disp('  The desired characteristic equation is of the form, with alc(n) = 1:')
disp(' ')
disp('    alc(n)*z^n + alc(n -1 )*z^(n - 1) + ... + alc(1)*z + alc(0) = 0')
disp(' ')
disp('  Enter the characteristic-equation coefficients in descending order')
disp('  of n, with each coefficient followed by pressing the enter key:')

for ii=1:(order+1)
   iii=order + 1 - ii;
   iiii=int2str(iii);
   str1=['    alc(',iiii,')= '];
   alc(ii) = input( str1);
end

disp(' ')
diary on
disp('  The characteristic-equation coefficients are:')
disp(' ')
alc
disp(' ')
AMB=B;
AMBT=B;

for n=2:order
   AMBT=A*AMBT;

   for nn=1:order
      AMB(nn,n)=AMBT(nn,1);
   end

end

AMBI=inv(AMB);
CC=polyvalm(alc,A);
CCC = AMBI*CC;
diary on
disp('  The gain matrix K is:')
disp(' ')
K=CCC(order,:)
disp(' ')
diary off
disp('  Press any key to continue ...'), pause
disp(' ')
diary on
disp('  The closed-loop system matrix AFB = (A - BK) is:')
disp(' ')
AFB=A-B*K
disp(' ')
diary off
disp('  Press any key to continue ...'), pause
disp(' ')
diary on
disp('  For verification, the closed-loop characteristic-equation ')
disp('  coefficients for the estimator, calculated from AFB, are:')
disp(' ')
alc=poly(AFB)
disp(' ')
disp('  The system characteristic-equation roots in rectangular form are:')
disp(' ')
r=roots(alc)
disp(' ')
disp('  The system characteristic-equation roots in polar form are:')
disp(' ')
magr=abs(r); angler=angle(r)*180/pi;
[magr,angler]
diary off
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print popa.dat
   clc
end

disp(' ')
disp('Press any key to return to the menu.'), pause, clc


