%SINGTR Singularity transformation.

%  Copyright
%  Charles L. Phillips  1994

delete sitr.dat
clc
disp('  This program calculates the matrices for a singularity')
disp('  transformation for a set of state matrices A, B, C, and D.')
disp('  The transformation matrix P results in the transformed matrices')
disp(' ')
disp('      Aw = inv(P)*A*P     Bw = inv(P)*B     Cw = C*P     Dw = D')
disp(' ')
disp('  Enter the required data as requested.')
disp(' '),
order = input('   Enter the system order = ');
disp(' ')
disp('  Enter the transformation matrix P, with each element followed')
disp('  by an enter:')
for ii=1:order
   for jj=1:order
      iii=int2str(ii);
      jjj=int2str(jj);
      str1=['   P(',iii,',',jjj,')= '];
      P(ii,jj) = input(str1);
   end
end
abcdin
disp(' ')
disp('  Press any key to continue ...'); pause, clc
diary sitr.dat
disp('  The entered matrices are:')
disp(' ')
P
A
B
C
D
disp(' ')
diary off
disp('  Press any key to continue ...'); pause, clc
diary on
disp('  The inverse of P is:')
disp(' ')
Pinv = inv(P)
disp(' ')
diary off
disp('  Press any key to continue ...'); pause, clc
diary on
disp('  The transformed matrices are:')
disp(' ')
Aw = Pinv*A*P
Bw = Pinv*B
Cw = C*P
Dw = D
disp(' ')
diary off
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the results printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print sitr.dat
end
clc

disp('  Press any key to return to the menu ...'); pause, clc


