%TIMRES Closed-loop time response, discrete system.

%  Copyright
%  Charles L. Phillips  1994

delete tr.dat
clc
clear tm y u
diary tr.dat
disp('                 CLOSED-LOOP SYSTEM TIME RESPONSE ')
disp(' ')
diary off
disp('  Simulation time: 0 <= t <= tf, with output every T seconds.')
tf=input(' Enter the simulation final time   tf = ');
order=length(Ccl);
x=zeros(order,1);  x1=zeros(order,1);
% iterative solution
iter=ceil(tf/T);
disp(' ')
disp('  The system input is of the form:')
disp(' ')
disp('     r(t) = k1 + k2*t + k3*cos(wt + theta)')
disp(' ')
k1=input('      Enter the coefficient   k1 = ');
k2=input('      Enter the coefficient   k2 = ');
k3=input('      Enter the coefficient   k3 = ');
w=input('      Enter the frequency      w = ');
theta=input('      Enter the phase      theta = ');
theta=theta*pi/180;
disp(' ')
disp('  Response being calculated ...')

for k=1:iter 
   u(k)=k1 + k2*k*T + k3*cos(w*k*T + theta);
   x1=Acl*x+Bcl*u(k);
   y(k)=Ccl*x;
   x=x1;
end

tm=0:T:(iter-1)*T;
disp(' ')
diary on
disp('  The system time response:')
disp(' ')
disp('     Time   Input   Output')
pr=length(tm);  count=3;

for i=1:pr
   [tm(i),u(i),y(i)]
   if count==11
diary off
      disp(' ')
      disp('  Press any key to continue ...'),disp(' '), pause
      count=0;
diary on
   end

   count=count+1;
end
disp(' ')
diary off
disp('  Press any key for a plot of the time response.'); pause
subplot(111), plot(tm,y,'-',tm,u,'--')
title('Time Response, Input --, Output -.')
xlabel('Time')
ylabel('Amplitude')
pause, clc
disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input('  Do you want the time response data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print tr.dat
end
clc

disp('  Press any key to return to the menu.'); pause, clc


