%TR Closed-loop initial-condition time response, discrete system.

%  Copyright
%  Charles L. Phillips  1994

delete tres.dat
clc
clear time1 tm x x1k
diary tres.dat
disp('                 CLOSED LOOP SYSTEM TIME RESPONSE ')
disp(' ')
diary off
disp('  Simulation time: 0 <= t <= tf, with output every T seconds.')
disp(' ')
tf=input(' Enter simulation final time   tf = ');
ordercl=order;

if estinc==1
   ordercl=2*order;

   if roeest==1
      ordercl=ordercl-1;
   end

end

x=zeros(ordercl,1);  x1=zeros(ordercl,1);
disp(' ')
disp('  The first n elements of the state vector are the states of the ')
disp('  plant.  The remaining elements are the estimates of the states,')
disp('  in order.')
disp(' ')
disp('  Enter the initial conditions in the order of x1(0), x2(0), ... :')

for ii=1:ordercl
   iiii=ii;
   iii=int2str(ii);
   ij=int2str(iiii);
   str1=['    x',ij,'(0)= '];
   x(ii) = input(str1);
end

% iterative solution
iter=ceil(tf/T);
%tm=0:T:(iter-1)*T;
count=3;
disp(' ')
diary on
disp('          SYSTEM STATES')
disp(' ')
disp('  time       x1(kT)   x2(kT) ...')

for k=1:iter 
   tm=(k-1)*T;
   [tm,x']
   time1(k)=tm;
   x1k(k)=x(1);

   if order < ordercl
      xnp1(k)=x(order+1);
   end

   if count==11
diary off
      disp(' ')
      disp('  Press any key to continue ...'),disp(' '), pause
      count=0;
diary on
   end  

   count=count+1;
   x1=ACL*x;
   x=x1;

end
diary off
disp('  Press any key for a plot of x1(kT).'); pause,clc
subplot(111), plot(time1,x1k)
title('Time Response, x1(kT)')
xlabel('Time')
ylabel('Amplitude')
grid
pause

disp(' ')
comp = computer;
if comp(1:2) ~= 'PC', clc, return, end
s=input(' Do you want the time-response data printed? [y/n]: ','s');
if s=='y'
   ! copy iden.dat prn:
   ! print tres.dat
   clc
end

disp(' ')
disp('  Press any key to return to the menu.'), pause,clc


